cy(4): Remove ISA support.
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 3.2 to later versions                +
13 +-----------------------------------------------------------------------+
14
15 SMP OPTION REMOVED
16 ------------------
17
18 The SMP kernel option has been made a no-op. All kernels now feature SMP
19 support. If you have 'options SMP' in your kernel config, you can as well
20 remove it.
21
22 DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
23 ---------------------------------------------------------------------------
24
25 The DEVICE_POLLING kernel option has been made a no-op and it has been
26 replaced by IFPOLL_ENABLE.  If you have 'options DEVICE_POLLING' in your
27 kernel config, you need to change it to IFPOLL_ENABLE.
28
29 Also, the KTR_POLLING kernel option has been removed, so it must be
30 removed from kernel configs that have it.
31
32 BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
33 ---------------------------------------------------
34
35 The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
36 cards will no longer be detected.
37
38 The same has been done for Stallion multiport serial controllers. stli(4)
39 has been completely removed (along with the stlload(8) and stlstty(8)
40 utilities) and stl(4) was changed to support only PCI cards. Similarly,
41 ISA support was removed from cy(4) too. All these drivers are i386 only.
42
43 +-----------------------------------------------------------------------+
44 +         UPGRADING DRAGONFLY FROM 3.0 to later versions                +
45 +-----------------------------------------------------------------------+
46
47 APIC_IO OPTION REMOVED
48 ----------------------
49
50 The APIC_IO kernel option is no longer accepted after having been without
51 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
52 If you have 'options APIC_IO' in your kernel config, you'll have to
53 remove it.
54
55 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
56 -----------------------------------------
57
58 The wdog framework is now compiled into our kernels by default, so the
59 options are no longer needed.
60
61 DOSCMD(1) REMOVED
62 -----------------
63
64 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
65 NO_X make.conf option was removed too.
66
67 GCC 4.7
68 -------
69
70 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
71 default compiler in base (default is still GCC 4.4).
72
73 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
74 NO_GCC47 in /etc/make.conf.
75
76 USB4BSD
77 -------
78
79 A new USB stack (from FreeBSD) has been brought in. The following
80 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
81 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
82 and uaudio.
83
84 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
85 be put in make.conf and device "usb4bsd" (quotes needed) has to
86 replace device usb in the kernel config. After that, a full
87 build/install/upgrade cycle is needed.
88
89 Note that this is experimental and incomplete, but we are interested
90 in hearing about issues with it, of course.
91
92 +-----------------------------------------------------------------------+
93 +         UPGRADING DRAGONFLY FROM 2.10 to later versions               +
94 +-----------------------------------------------------------------------+
95
96 SEVERAL ISA DRIVERS REMOVED
97 ---------------------------
98
99 The following ISA only drivers have been removed along with a couple of
100 associated userland tools:
101
102 aha(4)
103 asc(4) & sasc(1)
104 ctx
105 dgb(4)
106 el(4)
107 gpib
108 gsc(4) & sgsc(1)
109 ie(4)
110 labpc(4)
111 le(4)
112 mse(4)
113 rc(4)
114 rdp(4)
115 spigot
116 tw(4) & xten(1) & xtend(8)
117 wl(4) & wlconfig(8)
118 wt(4)
119
120 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
121 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
122 file.
123
124 If buildkernel complains about any of these drivers, just remove them
125 from your kernel configuration.
126
127 BINUTILS 2.20
128 -------------
129 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
130 values of BINUTILSVERS are now binutils221 and binutils222 (default).
131
132 BUILDWORLD/-KERNEL PARALLELIZATION WORK
133 ---------------------------------------
134 Due to changes in the way we build with more than one make job, you
135 will have to update install(1) and mkdir(1) prior to buildworld if you
136 want to build with 'make -j':
137
138 cd /usr/src/usr.bin/xinstall; make; make install; make clean
139 cd /usr/src/bin/mkdir; make; make install; make clean
140
141 DMA(8) UPGRADE
142 --------------
143 dma(8) has been upgraded to v0.7 which no longer supports the
144 /etc/dma/virtusertable. Some of its functionality has been replaced
145 with the MASQUERADE keyword and the EMAIL environment variable (see
146 the dma(8) manual page).
147
148 +-----------------------------------------------------------------------+
149 +         UPGRADING DRAGONFLY FROM 2.8 to later versions                +
150 +-----------------------------------------------------------------------+
151
152 GCC 4.4 & BINUTILS 2.21
153 -----------------------
154
155 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
156 been made DragonFly's default Binutils.
157
158 That means that any settings that set CCVER to 'gcc44' are not needed
159 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
160 GCC 4.1.
161
162 It also means that 'binutils221' as a value for BINUTILSVER has no
163 effect anymore. 2.17 has been removed and 'binutils220' is available
164 as an option.
165
166 The NO_GCC44 option has been removed and will not affect the build
167 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
168 building in a similar fashion.
169
170 Note that you must do a full buildworld/buildkernel for upgrading.
171
172 pkg_radd settings
173 -----------------
174
175 The config file for pkg_radd has moved from /etc/settings.conf to 
176 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
177 if this is needed.  This warning only applies if /etc/settings.conf 
178 exists.  pkg_radd will continue to work with defaults.
179
180 +-----------------------------------------------------------------------+
181 +         20100927                                                      +
182 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
183 +-----------------------------------------------------------------------+
184
185 OpenSSL
186 --------
187
188 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
189 This shouldn't break any 3rd-party software, but you'll need to recompile your
190 3rd-party software if you want it to link against the new version of OpenSSL.
191
192 Loader
193 -------
194
195 A new loader (dloader) has been added which better handles booting from
196 multiple kernel/module versions.
197
198 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
199
200         cd /usr/src
201         make buildworld
202         make installworld
203         make upgrade
204         make buildkernel KERNCONF=<KERNELNAME>
205         make installkernel KERNCONF=<KERNELNAME>
206
207 Note that you must installworld and run the 'upgrade' target before
208 installing the new kernel.
209
210 BIND
211 -----
212
213 BIND has been removed from the base system.  The ldns and drill tools have 
214 been added for basic functionality.  Use 'drill' where you would normally 
215 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
216 net/bind95, net/bind96, or net/bind97 as of this writing.
217
218 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
219 include BIND as a pkgsrc package.
220
221 +-----------------------------------------------------------------------+
222 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
223 +                               GENERAL                                 +
224 +-----------------------------------------------------------------------+
225
226 Instructions on how to obtain and maintain DragonFly source code using git
227 are in the development(7) manual page.
228
229 To upgrade a DragonFly system from sources you run the following sequence:
230
231         cd /usr/src
232         make buildworld
233         make buildkernel KERNCONF=<KERNELNAME>
234         make installkernel KERNCONF=<KERNELNAME>
235         make installworld
236
237 You will also want to run the 'upgrade' target to upgrade your /etc and the
238 rest of your system.  The upgrade target is aware of stale files created by
239 older DragonFly installations and should delete them automatically.
240
241         make upgrade
242
243 See the build(7) manual page for further information.
244
245 Once you've done a full build of the world and kernel you can do incremental
246 upgrades of either by using the 'quickworld' and 'quickkernel' targets
247 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
248 the quick targets, try updating your repo first, and then a full buildworld
249 and buildkernel as shown above, before asking for help.
250
251 +-----------------------------------------------------------------------+
252 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
253 +-----------------------------------------------------------------------+
254
255 In 2.1 kernel and modules has moved to boot directory.  For most cases
256 this is handled automatically by 'make upgrade'.  A few cases needs manual
257 intervention:
258
259  * When installing a kernel without first doing a make buildworld,
260    installworld and upgrade to the same DESTDIR as kernel:
261    make DESTDIR/boot directory and move kernel and modules into this boot
262    directory; also move kernel.old and modules.old.
263    Typical example is vkernel(7), use (no modules used):
264
265         cd /var/vkernel
266         mkdir boot
267         chflags noschg kernel
268         mv kernel kernel.old boot
269         chflags schg boot/kernel
270         
271  * When using a boot-only partition, /boot/loader.rc needs to be edited:
272    delete occurrences of '/boot/'.
273    These occurences can normally be deleted in any case, see loader(8).
274
275 +-----------------------------------------------------------------------+
276 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
277 +-----------------------------------------------------------------------+
278
279 In 1.9 major changes to the disk management infrastructure have taken
280 place.  make upgrade may not catch all of your disk devices in /dev,
281 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
282 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
283 and MAKEDEV no longer exists.
284
285 The biggest changes in 1.9 are:
286
287 (1) That whole-slice devices such as da0s1 no longer share the same device
288     id as partition c devices such as da0s1c.
289
290 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
291     with no snooping or reserved sectors.  Consequently you cannot run
292     disklabel on this device.  Instead you must run disklabel on a
293     whole-slice device.
294
295 (3) The 'compatibility' partitions now use slice 0 in the device name,
296     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
297     accessing the disklabel for the compatibility partitions must be
298     done via slice 0 (da0s0).
299
300 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
301     and CCD now run through the disk management layer and are assigned
302     real disk management devices.   VN and CCD in particular do not usually
303     use a MBR and disklabels must be accessed through the compatibility
304     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
305     don't name it 'ccd0s0' in the config file.
306
307 Generally speaking, you have to get used to running fdisk and disklabel on
308 the correctly specified device names.  A lot of the wiggle, such as running
309 disklabel on a partition, has been removed.
310
311 +-----------------------------------------------------------------------+
312 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
313 +-----------------------------------------------------------------------+
314
315 > Kerberos IV
316 -------------
317
318 Kerberos IV (eBones) was removed from the tree, please consider moving to
319 Kerberos 5 (Heimdal).
320
321 > Package Management System
322 ---------------------------
323
324 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
325 management system.  The necessary tools to build and maintain packages
326 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
327 directories are in your PATH variable.
328
329 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
330 the tarball from NetBSD:
331
332         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
333         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
334
335 This tree can then be kept up to date with cvs update:
336
337         cd /usr/pkgsrc; cvs up
338
339 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
340 build and install the pkgsrc bootstrap manually:
341
342         cd /usr/pkgsrc/bootstrap
343         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
344
345 +-----------------------------------------------------------------------+
346 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
347 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
348 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
349 +-----------------------------------------------------------------------+
350
351 The compatibility shims for the build environment have been removed, you
352 have to update to DragonFly 1.2 release branch first.
353
354 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
355 The existing configuration can be converted using /etc/pam.d/convert.sh.
356 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
357 the pam_skey.so module was retired, you have to remove it manually from
358 your configuration, when you convert it.
359
360 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
361 ---------------------
362
363 The following users may be missing from your password file.  Use vipw and
364 add any that are missing:
365
366 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
367 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
368
369 The following groups may be missing from your group file.  Use vi /etc/group
370 and add any that are missing:
371
372 smmsp:*:25:
373 authpf:*:63:
374 _pflogd:*:64:
375
376
377 > Upgrading to DragonFly from FreeBSD
378 ---------------------
379
380 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
381 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
382 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
383 make depend information, it starts from scratch, so no pre-cleaning of the
384 object hierarchy is necessary.
385
386         # get the CVS repository (it is placed in /home/dcvs, 500MB).
387         # Please use the -h option and a mirror site to pull the 
388         # initial repository, but feel free to use the main repository
389         # machine to pull updates.
390         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
391         # install the source from the CVS hierarchy (remove preexisting
392         # FreeBSD src first) (500MB)
393         cd /usr
394         rm -rf src
395         cvs -R -d /home/dcvs checkout -P src
396
397         # build it (500MB used in /usr/obj)
398         #
399         cd /usr/src
400         make buildworld
401         make buildkernel KERNCONF=<KERNELNAME>
402
403 Once you have built DragonFly you have to install it over FreeBSD.  Since
404 DragonFly does not track changes made by FreeBSD to its include file 
405 hierarchy and include file pollution can cause all sorts of unexpected
406 compilation issues to come up, it is best to wipe your include hierarchy
407 prior to installing DragonFly.  Note that you should not wipe any installed
408 FreeBSD header files or binaries until after you have successfully completed
409 the build steps above.
410
411         rm -rf /usr/include
412         mkdir /usr/include
413         make installkernel KERNCONF=<KERNELNAME>
414         make installworld
415
416 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
417 will unconditionally upgrade the /etc files that sysops do not usually
418 mess around with, such as the files in /etc/rc.d.  It will also remove any
419 obsolete files such as utilities and manpages that have been removed from
420 the system since the version you're coming from.  If you are unsure we 
421 recommend that you make a backup of at least your /etc before applying
422 this step.  Note that DragonFly's RC system is basically RCNG from
423 FreeBSD-5, but there are some differences in the contents of the RC files.
424
425         make upgrade
426
427 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
428 Doing so might leave your system in an unusable state.
429
430 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
431 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
432 report these files to the DragonFly developers so that they can be added to
433 the 'upgrade' target.
434